// RgL
/*-----------------------------------------------------------------------------
[]	ShitarabianView.cpp
[Tv]	CShitarabianView ̎
[l]	Ȃ
[]	2003-11-08	b031031 (3199) f[^ǂݍݑOɕ\XV悤ƂƁA݂Ȃsɍsė
		2003-11-08	b031031 (3184) s\PɕύX
-----------------------------------------------------------------------------*/
#include "stdafx.h"
#include "Common.h"
#include "Shitarabian.h"
#include "MainFrm.h"

#include "ShitarabianDoc.h"
#include "ShitarabianView.h"

#include "imm.h"
#include "EditDrawer.h"
#include "CommandManager.h"
#include "CommandInput.h"
#include "CommandCaret.h"
#include "CommandDelete.h"
#include "GeneralSetting.h"
#include <process.h>
#include "Selection.h"
#include "BoxSelection.h"
#include "FloatingSelection.h"
#include "CommandMultiEdit.h"
#include "Padding.h"
#include "TokenReader.h"
#include "ToolBarManager.h"
#include "ShitarabianPlugInManager.h"
#include "Selection.h"
#include "ROISelection.h"
#include "ExeCommon.h"

#include "EmphasisLine.h"


extern CShitarabianApp	theApp;
extern CStatusBar*		m_pSystemStatusBar; 



// IMECompositionEBhE̐ݒ@
// http://mambo.kuhp.kyoto-u.ac.jp/~miyoshi/mked/index.html

// Lbg̕\E\
// pDoc->SetAllUpdate();ōĕ`sƂALbg̍č쐬sB
// Lbg\ɂHideCaret܂̂ŁALbg̕\JnɕKvB

static CEditDrawer*	GetDrawer()
{
	return( CEditDrawer::GetInstance() );
}


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CShitarabianView

IMPLEMENT_DYNCREATE(CShitarabianView, CView)

BEGIN_MESSAGE_MAP(CShitarabianView, CView)
	//{{AFX_MSG_MAP(CShitarabianView)
	ON_WM_SETFOCUS()
	ON_WM_KILLFOCUS()
	ON_WM_ERASEBKGND()
	ON_WM_SETCURSOR()
	ON_WM_DROPFILES()
	ON_WM_VSCROLL()
	ON_WM_HSCROLL()
	ON_WM_MOUSEWHEEL()
	ON_COMMAND(IDM_EDIT_MODESELECT, OnEditModeselect)
	ON_WM_RBUTTONDOWN()
	ON_WM_SIZE()
	ON_COMMAND(IDM_EDIT_FLOAT_CANCEL, OnEditFloatCancel)
	ON_COMMAND(IDM_EDIT_FLOAT_COPY, OnEditFloatCopy)
	ON_COMMAND(IDM_EDIT_FLOAT_MOVE, OnEditFloatMove)
	//}}AFX_MSG_MAP
	// WR}h
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CShitarabianView NX̍\z/

CShitarabianView::CShitarabianView():
	m_bVisibleCaret( FALSE ),
	m_bDrag( FALSE ),
	m_bInputMode( FALSE ),
	m_idxUpdateStartRow( AllRow ),
	m_idxUpdateEndRow( AllRow ),
	m_iFloatOffsetX( 0 ),
	m_iFloatOffsetY( 0 ),
	m_lMaxXPixel( 0 ),
	m_nRow( 0 ),
	m_iPrevVisibleRowStart( -1 ),
	m_iPrevVisibleRowCount( -1 )
{
	// XN[o[̏
	ResetHScroll();
}

CShitarabianView::~CShitarabianView()
{
}


/////////////////////////////////////////////////////////////////////////////
// CShitarabianView NX̕`

void CShitarabianView::OnDraw(CDC* pDC)
{
	CShitarabianDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// Kvȕ̕`̈Đݒ肷
	{
		CRect		rcUpdateReq;
		if ( pDC->GetClipBox( &rcUpdateReq ) != NULLREGION )
		{
			CEditDrawer*	pDrawer = CEditDrawer::GetInstance();
			pDoc->SetUpdateStartRow( pDrawer->WindowPixelToCaretRowZoomed( rcUpdateReq.top, pDoc ) );
			pDoc->SetUpdateEndRow( pDrawer->WindowPixelToCaretRowZoomed( rcUpdateReq.bottom, pDoc )+1 );

			DrawPage(
				pDC,
				&rcUpdateReq
			);
		}
		else
		{
			DrawPage( pDC );
		}
	}
}

void CShitarabianView::OnInitialUpdate()
{
	CView::OnInitialUpdate();

	// hLgƃIuWFNg̊֘Aݒ
	CCommandManager*	pCmd = CCommandManager::GetInstance();
	pCmd->Attach( GetDocument() );

	// Drop
	DragAcceptFiles( TRUE );
}

/////////////////////////////////////////////////////////////////////////////
// CShitarabianView NẌ



void CShitarabianView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
}

void CShitarabianView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
}

/////////////////////////////////////////////////////////////////////////////
// CShitarabianView NX̐ff

#ifdef _DEBUG
void CShitarabianView::AssertValid() const
{
	CView::AssertValid();
}

void CShitarabianView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CShitarabianDoc* CShitarabianView::GetDocument() // fobO o[W̓CCłB
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CShitarabianDoc)));
	return (CShitarabianDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CShitarabianView NX̃bZ[W nh


void CShitarabianView::DrawCaret(
	CDC*	pDC
) 
{
	CShitarabianDoc* pDoc = GetDocument();
	if ( !m_bVisibleCaret )
	{
		return;	
	}

	switch( pDoc->GetOperationMode() )
	{
	case OperationNormal:
		break;
	default:
		return;
		break;
	}

	CEditDrawer*	pDrawer = GetDrawer();

	long	lLeftMargin;
	long	lTopMargin;
	lLeftMargin = CGeneralSetting::GetInstance()->GetLeftMargin();
	lTopMargin = CGeneralSetting::GetInstance()->GetTopMargin();

	// Lbg̔zu
	POINT	ptCaret;
	{
		CShitarabianDoc* pDoc = GetDocument();
		long	idxRow = 0;
		long	idxColumn = 0;
		// hLgLbg擾
		{
			if( pDoc != NULL )
			{
				idxRow = pDoc->GetCaretRow();
				idxColumn = pDoc->GetCaretColumn();
			}
		}
		// Lbg񂩂Lbg̃sNZWvZ
		{
			CEmphasisLine*	pEmphasisLine = pDoc->GetEmphasisLine( idxRow );
			if ( pEmphasisLine != NULL )
			{
				ptCaret.x = pEmphasisLine->CaretColumnToPixelZoomed( idxColumn );
				ptCaret.y = pDrawer->CaretRowToPixelZoomed( idxRow );
			}
			else
			{
				ptCaret.x = lLeftMargin;
				ptCaret.y = lTopMargin;
			}
		}

		// XN[{bNX̍Wɕϊ
		ptCaret = PixelToScrollBox( CPoint(ptCaret.x, ptCaret.y) );
		if ( ptCaret.x < lLeftMargin )
		{
			ptCaret.x = -2*pDrawer->GetZoom();
		}
		if ( ptCaret.y < lTopMargin )
		{
			ptCaret.x = -2*pDrawer->GetZoom();
		}

		SetCaretPos( ptCaret );


		if ( !pDoc->IsOverwriteMode() )
		{
			ShowCaret();
		}

	}


	// IME̔zu
	{
		HIMC hIMC = ImmGetContext( m_hWnd );

		// zu
		COMPOSITIONFORM cf;
		cf.dwStyle = CFS_POINT;
		cf.ptCurrentPos = ptCaret;
		ImmSetCompositionWindow(hIMC, &cf);

		// tHgTCY̐ݒ
		LOGFONT*	pLogFont = CGeneralSetting::GetInstance()->GetLogFont()->GetLogFont( pDC );
		pLogFont->lfHeight *= pDrawer->GetZoom();
		ImmSetCompositionFont( hIMC, pLogFont );
		pLogFont->lfHeight /= pDrawer->GetZoom();

		ImmReleaseContext( m_hWnd, hIMC );
	}
}


CPoint CShitarabianView::PixelToScrollBox(
	CPoint	ptPixel
)
{
	CPoint	ptClientTopLeft;
	ptClientTopLeft = GetDeviceScrollPosition();

	int		iLeftMargin = CGeneralSetting::GetInstance()->GetLeftMargin();
	int		iTopMargin = CGeneralSetting::GetInstance()->GetTopMargin();
	ptPixel.x -= ptClientTopLeft.x - iLeftMargin;
	ptPixel.y -= ptClientTopLeft.y - iTopMargin;
	return( ptPixel );
}


CPoint CShitarabianView::ScrollBoxToPixel(
	CPoint	ptPixel
)
{
	CPoint	ptClientTopLeft;
	ptClientTopLeft = GetDeviceScrollPosition();

	int		iLeftMargin = CGeneralSetting::GetInstance()->GetLeftMargin();
	int		iTopMargin = CGeneralSetting::GetInstance()->GetTopMargin();
	ptPixel.x += ptClientTopLeft.x - iLeftMargin;
	ptPixel.y += ptClientTopLeft.y - iTopMargin;

	CEditDrawer*	pDrawer = GetDrawer();
	ptPixel.x = ptPixel.x / pDrawer->GetZoom();
	ptPixel.y = ptPixel.y / pDrawer->GetZoom();
	return( ptPixel );
}



	
// Lbg悤ɃXN[
BOOL	CShitarabianView::ScrollToCaret()
{
	CShitarabianDoc* pDoc = GetDocument();
	int idxRow = pDoc->GetCaretRow();
	int idxColumn = pDoc->GetCaretColumn();
		CEditDrawer*	pDrawer = CEditDrawer::GetInstance();

	BOOL	bVScroll = FALSE;
	BOOL	bHScroll = FALSE;
	HDC		hdc = ::GetDC( NULL );
	CDC		DC;
	DC.Attach( hdc );
	{
		// LbgPixelWvZ
		CEmphasisLine*	pEmphasisLine = pDoc->GetEmphasisLine( idxRow );
		if ( pEmphasisLine != NULL )
		{
			// IW̃Lbgʒu擾
			long	lPixelX = pEmphasisLine->CaretColumnToWindowPixelZoomed( idxColumn );
			long	lPixelY = pDrawer->CaretRowToWindowPixelZoomed( idxRow );

			// XN[{bNXɎ܂邩H
			CPoint	ptClientTopLeft;
			ptClientTopLeft = GetDeviceScrollPosition();
			POINT	ptScrollBoxTopLeft;
			ptScrollBoxTopLeft.x = ptClientTopLeft.x;
			ptScrollBoxTopLeft.y = ptClientTopLeft.y;

			int		iColumnWidth = pDrawer->GetBlankWidth() * pDrawer->GetZoom();
			int		iRowHeight = pDrawer->GetBlankHeight() * pDrawer->GetZoom();
			int		iLeftMargin = CGeneralSetting::GetInstance()->GetLeftMargin();
			int		iTopMargin = CGeneralSetting::GetInstance()->GetTopMargin();

			CRect	rcClient;
			GetClientRect( &rcClient );
			if ( lPixelX < ptClientTopLeft.x+iLeftMargin )
			{
				ptScrollBoxTopLeft.x = lPixelX-iLeftMargin;
				bHScroll = TRUE;
			}
			if ( lPixelX+iColumnWidth > ptClientTopLeft.x+rcClient.Width() )
			{
				ptScrollBoxTopLeft.x = lPixelX+iColumnWidth - rcClient.Width();
				bHScroll = TRUE;
			}
			if ( lPixelY < ptClientTopLeft.y+iTopMargin )
			{
				ptScrollBoxTopLeft.y = lPixelY-iTopMargin;
				bVScroll = TRUE;
			}
			if ( lPixelY+iRowHeight > ptClientTopLeft.y+rcClient.Height() )
			{
				ptScrollBoxTopLeft.y = lPixelY+ iRowHeight - rcClient.Height();
				bVScroll = TRUE;
			}

			// ܂Ȃ΃XN[
			if ( bVScroll )
			{
				// hLg傫ωĂꍇl
				// XN[{bNẌƂ肠Lbgʒȗ傫ȏɂ
				m_lMaxXPixel = max( m_lMaxXPixel, lPixelX-iLeftMargin );
				RecalcScrollBar();

				// XN[{bNX̉摜炷Kvȗ̈ĕ`
				ManualVScroll( ptScrollBoxTopLeft.y );
			}
			if ( bHScroll )
			{
				// hLg傫ωĂꍇl
				// XN[{bNẌƂ肠Lbgʒȗ傫ȏɂ
				m_lMaxXPixel = max( m_lMaxXPixel, lPixelX-iLeftMargin );
				RecalcScrollBar();

				// XN[{bNX̉摜炷Kvȗ̈ĕ`
				ManualHScroll( ptScrollBoxTopLeft.x );
			}
		}
	}
	DC.Detach();
	::ReleaseDC( NULL, hdc );

	return( bVScroll || bHScroll );
}


CPoint	CShitarabianView::GetDeviceScrollPosition()
{
	CPoint	pt;
	SCROLLINFO	tInfo;

	if ( GetScrollInfo( SB_VERT, &tInfo ) )
	{
		pt.y = tInfo.nPos;
	}
	if ( GetScrollInfo( SB_HORZ, &tInfo ) )
	{
		pt.x = tInfo.nPos;
	}

	return( pt );
}

void	CShitarabianView::SetDeviceScrollPosition( CPoint pt )
{
	SCROLLINFO	tInfo;

	GetScrollInfo( SB_VERT, &tInfo );
	tInfo.nPos = min( pt.y, tInfo.nMax );
	SetScrollInfo( SB_VERT, &tInfo );

	GetScrollInfo( SB_HORZ, &tInfo );
	tInfo.nPos = min( pt.x, tInfo.nMax );
	SetScrollInfo( SB_HORZ, &tInfo );
}

void CShitarabianView::SetScrollSizes(
	CSize	sizeDocument,
	CSize	sizePage,
	CSize	sizeLine
)
{
	// warning C4100:x̖
	sizeLine;

	SCROLLINFO	tInfo;

	// c
	GetScrollInfo(
		SB_VERT,
		&tInfo
	);
	tInfo.fMask = SIF_DISABLENOSCROLL | SIF_ALL; 
	tInfo.nMin = 0; 
	tInfo.nMax = sizeDocument.cy; 
	tInfo.nPage = sizePage.cy;
	SetScrollInfo(
		SB_VERT,
		&tInfo,
		TRUE
	);

	// 
	GetScrollInfo(
		SB_HORZ,
		&tInfo
	);
	tInfo.fMask = SIF_DISABLENOSCROLL | SIF_ALL; 
	tInfo.nMin = 0; 
	tInfo.nMax = sizeDocument.cx; 
	tInfo.nPage = sizePage.cx;
	SetScrollInfo(
		SB_HORZ,
		&tInfo,
		TRUE
	);
}

// ̊Jns
int CShitarabianView::VisibleRowStart()
{
	CPoint	ptScrollBox = GetDeviceScrollPosition();

	CEditDrawer*		pDrawer = GetDrawer();
	int	lRowHeight = pDrawer->CaretRowToPixelZoomed( 1 );

	return( ptScrollBox.y / lRowHeight );
}

// ̍s
int CShitarabianView::VisibleRowCount()
{
	CRect	rcClient;
	GetClientRect( &rcClient );

	CEditDrawer*		pDrawer = GetDrawer();
	int	lRowHeight = pDrawer->CaretRowToPixelZoomed( 1 );

	return( (rcClient.Height()-CGeneralSetting::GetInstance()->GetTopMargin()) / lRowHeight );
}




// XN[{bNX̉摜炷Kvȗ̈ĕ`
// cړ̂Ƃւ͂Ȃ
void CShitarabianView::UpdateScrollBox(
	CPoint		ptOldBox,
	CPoint		ptNewBox,
	CRect		rcClient
) 
{
	CEditDrawer*	pDrawer = GetDrawer();
	CShitarabianDoc* pDoc = GetDocument();

	if ( ptNewBox.y < 0 )
	{
		ptNewBox.y = 0;
	}
	if ( ptNewBox.y > GetScrollLimit(SB_VERT) )
	{
		ptNewBox.y = GetScrollLimit(SB_VERT);
	}

	// XV̈vZ
	int		iTop;
	int		iBottom;

	// ֈړꍇ
	if ( ptNewBox.y <  ptOldBox.y )
	{
		// ͐V\̈ɂȂ镔
		iTop = ptNewBox.y;
		// ͍܂ŕ\Ă͂
		iBottom = ptOldBox.y;
// MARK R00004(2002.09.16) XN[
		iBottom = min( iBottom, ptNewBox.y + rcClient.Height() );
// MARK R00004 end


		if ( m_idxUpdateStartRow == InitialRow )
		{
			m_idxUpdateStartRow = ( pDrawer->PixelToCaretRowZoomed(iTop, pDoc) );
		}
		else
		{
			m_idxUpdateStartRow = min( m_idxUpdateStartRow, pDrawer->PixelToCaretRowZoomed(iTop, pDoc) );
		}

		if ( m_idxUpdateStartRow == AllRow )
		{
			m_idxUpdateEndRow = pDrawer->PixelToCaretRowZoomed(iBottom, pDoc);
		}
		else
		{
			m_idxUpdateEndRow = max( m_idxUpdateEndRow, pDrawer->PixelToCaretRowZoomed(iBottom, pDoc) );
		}
	}
	else if ( ptNewBox.y >  ptOldBox.y )
	{
		// ͍܂ŕ\Ă͂
		iTop = ptOldBox.y + rcClient.Height();
// MARK R00004(2002.09.16) XN[
		iTop = max( iTop, ptNewBox.y );
// MARK R00004 end

		// ͐V\̈ɂȂ鉺͂
		iBottom = ptNewBox.y + rcClient.Height();

		if ( m_idxUpdateStartRow == InitialRow )
		{
			m_idxUpdateStartRow = ( pDrawer->WindowPixelToCaretRowZoomed(iTop, pDoc) );
		}
		else
		{
			m_idxUpdateStartRow = min( m_idxUpdateStartRow, pDrawer->WindowPixelToCaretRowZoomed(iTop, pDoc) );
		}
		m_idxUpdateEndRow = ( AllRow );
	}

	// C[W̃XN[
	{
		//@cړ̏ꍇBitBltŏȗ͉ł
		long	lLeftMargin;
		long	lTopMargin;
		lLeftMargin = CGeneralSetting::GetInstance()->GetLeftMargin();
		lTopMargin = CGeneralSetting::GetInstance()->GetTopMargin();
		CRect	rcClip(
			0,//lLeftMargin,
			lTopMargin,
			rcClient.Width(),
			rcClient.Height()
		);
		ScrollWindow(
			ptOldBox.x - ptNewBox.x,	// ɃXN[
			ptOldBox.y - ptNewBox.y,	// ɃXN[
			NULL,						// XN[NCAg̈̕
			&rcClip						// XN[NbsOlp`
		);
	}
}








void CShitarabianView::DrawPage(
	CDC*	pDC,
	CRect*	prcRequest
)
{
	CEditDrawer*	pDrawer = GetDrawer();
	CShitarabianDoc* pDoc = GetDocument();

	long	lMaxScrollWidth = m_lMaxXPixel;
	long	iStartRow = m_idxUpdateStartRow;
	long	iEndRow = m_idxUpdateEndRow;

	// \̈擾
	CRect	rcClient;		// EBhẼNCAg
	CPoint	ptScrollBox;	// XN[{bNẌʒu
	GetClientRect( &rcClient );
	ptScrollBox = GetDeviceScrollPosition();

	// XV̈擾
	CRect	rcUpdate;		// XV̈ [XN[{bNXW] (-)
	if ( prcRequest != NULL )
	{
		rcUpdate = *prcRequest;
		rcUpdate.left -= CGeneralSetting::GetInstance()->GetLeftMargin();
		rcUpdate.right -= CGeneralSetting::GetInstance()->GetLeftMargin();
		rcUpdate.top -= CGeneralSetting::GetInstance()->GetTopMargin();
		rcUpdate.bottom -= CGeneralSetting::GetInstance()->GetTopMargin();
	}
	else
	{
		// XV`vZ
		CRect		rcUpdateReq;
//		if ( pDC->GetClipBox( &rcUpdate ) == NULLREGION )
		{
			pDC->GetClipBox( &rcUpdateReq );
			rcUpdate.left = ptScrollBox.x;
			rcUpdate.right = rcUpdate.left + rcClient.Width();

			// zWŎgpő`vZ
			rcUpdate.top = 0;
			rcUpdate.bottom = 0;

			if ( iStartRow == AllRow )
			{
				rcUpdate.top = ptScrollBox.y;
			}
			else
			{
				if ( iStartRow != InitialRow )
				{
					rcUpdate.top = pDrawer->CaretRowToPixelZoomed( iStartRow );
					rcUpdate.top = max( ptScrollBox.y, rcUpdate.top );
				}
				if ( iEndRow != InitialRow )
				{
					rcUpdate.bottom = pDrawer->CaretRowToPixelZoomed( iEndRow );
					rcUpdate.bottom = min( rcUpdate.bottom, rcUpdate.top+rcClient.Height() );
				}
			}

			if( iEndRow == AllRow )
			{
				rcUpdate.bottom = ptScrollBox.y+rcClient.Height();
			}
		}
	}
	pDrawer->SetUpdateRect( rcUpdate );


	// `\z
	{
		int		iStartLine = pDrawer->PixelToCaretRowZoomed( rcUpdate.top, pDoc );
		int		iEndLine = pDrawer->PixelToCaretRowZoomed( rcUpdate.bottom, pDoc );

		TRACE( "CShitarabianView::DrawPage č\zs-> %d - %d\n", iStartLine, iEndLine );

		int		idxLine;
		for( idxLine=iStartLine ; idxLine<=iEndLine ; idxLine++ )
		{
			CEmphasisLine*	pLine = pDoc->GetEmphasisLine( idxLine );
			if ( pLine != NULL )
			{
				pLine->Analize();
			}
//			pDoc->AnalizeMultiLineEmphasis(
//				CGeneralSetting::GetInstance()->GetEmphasisDefine(),
//				idxLine
//			);
		}

		// `̈g
//		rcUpdate.bottom = max(
//			rcUpdate.bottom,
//			pDrawer->CaretRowToPixelZoomed( m_idxUpdateEndRow+1 )
//		);
	}

	// ʑS̃^C~OŃLbg蒼B
	switch( pDoc->GetOperationMode() )
	{
	case OperationNormal:
		if ( m_bVisibleCaret )
		if ( !pDoc->IsOverwriteMode() )
		if ( iStartRow == 0 )
		if ( iEndRow == AllRow )
		{
			DestroyCaret();
			CreateSolidCaret(
				2*pDrawer->GetZoom(),
				pDrawer->GetBlankHeight() * pDrawer->GetZoom()
			);
			ShowCaret();
		}
		break;
	default:
		break;
	}

	// eLXg̕\
	{
		HideCaret();

		CRgn	rgn;
		rgn.CreateRectRgn(
			0,
			CGeneralSetting::GetInstance()->GetTopMargin(),
			rcClient.right,
			rcClient.bottom
		);
		pDC->SelectClipRgn(
			&rgn,
			RGN_AND
		);

		// \švZ
		int		iStartLine = pDrawer->PixelToCaretRowZoomed( rcUpdate.top, pDoc );
		int		iEndLine = pDrawer->PixelToCaretRowZoomed( rcUpdate.bottom, pDoc );

		int		idxLine;
		for( idxLine=iEndLine ; idxLine>=iStartLine ; idxLine-- )
		{
			// s`
			long	lXPixel;
			lXPixel = pDrawer->DrawZoomedLine(
				pDoc,
				pDC,
				idxLine,
				ptScrollBox.x,
				pDrawer->CaretRowToPixelZoomed( idxLine )
			);

			lXPixel += pDrawer->GetEOFWidth()*pDrawer->GetZoom();
			if ( lXPixel > m_lMaxXPixel*pDrawer->GetZoom() )
			{
				m_lMaxXPixel = lXPixel/pDrawer->GetZoom();
			}
		}

		SetPrevVisibleRow(
			VisibleRowStart(),
			VisibleRowCount()
		);

		pDC->SelectClipRgn( NULL );
		rgn.DeleteObject();

		pDrawer->DrawRuler(
				pDC,
				rcUpdate.left,
				ptScrollBox.y
		);

		// Lbg̕\
		if ( !pDoc->IsOverwriteMode() )
		{
			DrawCaret( pDC );
		}
	}

	// \e̕ωĂ΃XN[o[ݒ肵Ȃ
	// sωĂƂɂ RecalcScrollBar() KvB
	BOOL	bRecalcScrollBar = FALSE;
	if	( m_nRow != pDoc->GetLineCount() )
	{
		m_nRow = pDoc->GetLineCount();
		bRecalcScrollBar = TRUE;
	}
	if	( lMaxScrollWidth != m_lMaxXPixel )
	{
		bRecalcScrollBar = TRUE;
	}
	if ( bRecalcScrollBar )
	{
		RecalcScrollBar();
	}

	DrawStatusBar();


/*
	CEmphasysLine	Line;
	CEmphasisDefine*	pEmphasisDefine;
	pEmphasisDefine = CGeneralSetting::GetInstance()->GetEmphasisDefine();
	Line.SetString(
		*pDoc->GetLine( 0 )
	);
	Line.Draw(
		pDC,
		0,
		100,
		pEmphasisDefine,
		TRUE,
		TRUE,
		0,
		INT_MAX,
		FALSE
	);
*/

	// `Kv̈̏
	m_idxUpdateStartRow = InitialRow;
	m_idxUpdateEndRow = InitialRow;

	// XV̈斢ݒŌĂ΂Ă܂ꍇo邽߂
	// gp͏Ă݂B
	pDrawer->SetUpdateRect( CRect(0,0,0,0) );
}

void CShitarabianView::DrawStatusBar()
{
	CShitarabianDoc* pDoc = GetDocument();

	// 샂[hɂăXe[^Xo[\؂ւ
	CSelection* pSelection = pDoc->GetSelection();
	switch( pDoc->GetOperationMode() )
	{
	case OperationNormal:
		if ( pSelection->IsSelected() )
		{
			// I𒆂łΑI\
			int idxStartRow = pSelection->GetSelectedStartRow();
			int idxEndRow = pSelection->GetSelectedEndRow();

			CString	str = pSelection->GetSelectedText();
			int	nRow = abs( idxStartRow - idxEndRow ) +1;
			int	nByte = str.GetLength();
			CString	strMes;
//  (3184) BGN 2003.11.08 (moralog) J\ǉ
//  original BGN 
//			strMes.Format( "I %dsi %dByte = %0.2fKB j", nRow, nByte, (double)nByte/1024 );
//			m_pSystemStatusBar->SetWindowText( strMes );
//  original END
			// JvZ
			int nColumn( 0 );
			{
				// ŏ̍sɂĒǉ
				if ( idxStartRow != idxEndRow )
				{
					CEmphasisLine*	pEmphasisLine = pDoc->GetEmphasisLine( idxStartRow );
					if ( pEmphasisLine != NULL)
					{
						nColumn += pEmphasisLine->GetColumnCount() - pSelection->GetSelectedStartColumn();
					}
				}

				// PsۂƑI𒆂̍sɂĒǉ
				int	idxRow;
				for( idxRow=idxStartRow+1 ; idxRow<idxEndRow ; idxRow++ )
				{
					CEmphasisLine*	pEmphasisLine = pDoc->GetEmphasisLine( idxRow );
					if ( pEmphasisLine != NULL)
					{
						nColumn += pEmphasisLine->GetColumnCount();
					}
				}

				// Ō̍sɂĒǉ
				if ( idxStartRow != idxEndRow )
				{
					CEmphasisLine*	pEmphasisLine = pDoc->GetEmphasisLine( idxEndRow );
					if ( pEmphasisLine != NULL)
					{
						nColumn += pSelection->GetSelectedEndColumn();
					}
				}

				// Ps̏ꍇɂĒǉ
				if ( idxStartRow == idxEndRow )
				{
					CEmphasisLine*	pEmphasisLine = pDoc->GetEmphasisLine( idxStartRow );
					if ( pEmphasisLine != NULL)
					{
						nColumn += pSelection->GetSelectedEndColumn() - pSelection->GetSelectedStartColumn();
					}
				}
			}
			strMes.Format( _T("I %d s@%d J i %dByte = %0.2fKB j"), nRow, nColumn, nByte, (double)nByte/1024 );
//  (3184) END
			m_pSystemStatusBar->SetWindowText( strMes );
		}
		else
		{
			// I𒆂łȂ΃Lbg\
			CString	strMes;
//  (3199) BGN 2003.11.08 (moralog) f[^ǂݍݑOɕ\XV悤ƂƁA݂Ȃsɍsė
//  (3184) BGN 2003.11.08 (moralog) s\PɕύX
//  original BGN 
//			strMes.Format( "%d/%d s@%d/%d J",
//				pDoc->GetCaretRow(),
//				pDoc->GetLineCount(),
//				pDoc->GetCaretColumn(),
//				pDoc->GetEmphasisLine( pDoc->GetCaretRow() )->GetColumnCount()
//			);
//  original END
			CEmphasisLine*	pEmphasisLine = pDoc->GetEmphasisLine( pDoc->GetCaretRow() );
			if ( pEmphasisLine != NULL)
			{
				strMes.Format( _T("%d/%d s@%d/%d J"),
					pDoc->GetCaretRow()+1,
					pDoc->GetLineCount(),
					pDoc->GetCaretColumn(),
					pEmphasisLine->GetColumnCount()
				);
			}
//  (3184) END
//  (3199) END

			m_pSystemStatusBar->SetWindowText( strMes );
		}
		break;

	case OperationBoxSelect:
		m_pSystemStatusBar->SetWindowText( "BOXI" );
		break;

	case OperationFloating:
		m_pSystemStatusBar->SetWindowText( "t[eBO\t" );
		break;

	case OperationROI:
		{
			CRect	rcROI = pDoc->GetROISelection()->GetROI();
			rcROI.NormalizeRect();
			CString	strMes;
			strMes.Format( "ROI:( %d, %d )-( %d, %d ) width=%d, height=%d",
				rcROI.left,rcROI.top,
				rcROI.right, rcROI.bottom,
				rcROI.Width(), rcROI.Height()
			);
			m_pSystemStatusBar->SetWindowText( strMes );
		}
		break;

	default:
		break;
	}

    // ㏑[h
	{
		CString		strOverWriteMode;
		if ( pDoc->IsOverwriteMode() )
		{
			strOverWriteMode.LoadString( IDS_MODE_OVERWRITE );
		}
		else
		{
			strOverWriteMode.LoadString( IDS_MODE_INSERT );
		}
		if ( m_pSystemStatusBar != NULL )
		{
			m_pSystemStatusBar->SetPaneText( m_pSystemStatusBar->CommandToIndex( IDS_STATUS_OVERWRITE ), strOverWriteMode );
		}
	}

	// I[h
	{
		CString		strOperationMode;
		switch( pDoc->GetOperationMode() )
		{
		case OperationBoxSelect:
			strOperationMode.LoadString( IDS_MODE_BOXSELECT );
			break;

		case OperationFloating:
			strOperationMode.LoadString( IDS_MODE_FLOATING );
			break;

		case OperationNormal:
			strOperationMode.LoadString( IDS_MODE_NORMAL );
			break;

		case OperationROI:
			strOperationMode.LoadString( IDS_MODE_ROI );
			break;

		default:
			strOperationMode.Empty();
			break;
		}
		if ( m_pSystemStatusBar != NULL )
		{
			m_pSystemStatusBar->SetPaneText( m_pSystemStatusBar->CommandToIndex( IDS_STATUS_OPERATION ), strOperationMode );
		}
	}
}

void CShitarabianView::RecalcScrollBar() 
{
	CEditDrawer*	pDrawer = GetDrawer();
	CShitarabianDoc* pDoc = GetDocument();

	int	lCharWidth = pDrawer->GetBlankWidth();
	int	iLineHeight = pDrawer->CaretRowToPixelZoomed( 1 );

	CRect	rcClient;		// EBhẼNCAg
	GetClientRect( &rcClient );

	long	lLeftMargin;
	lLeftMargin = CGeneralSetting::GetInstance()->GetLeftMargin();

	// y[W̑傫
	CSize	sizePage(
		rcClient.Width(),
		rcClient.Height()
	);

	// hLgŜ̑傫
	CSize	sizeDocument(
		lLeftMargin+ m_lMaxXPixel*pDrawer->GetZoom(),
		pDoc->GetLineCount() * iLineHeight + rcClient.Height()
	);

	// Ƃ̈ړ
	CSize	sizeLine(
		lCharWidth,
		iLineHeight
	);

	SetScrollSizes(
		sizeDocument,
		sizePage,
		sizeLine
	);
}


void CShitarabianView::ManualHScroll( long lPos ) 
{
	CSplitterWnd*	pSplitter = ((CMainFrame*)::AfxGetMainWnd())->GetSplitter();

	//  (3146) BGN 2003.11.21 (dincom) yC̑݃`FbN
	if ( pSplitter->GetColumnCount() * pSplitter->GetRowCount() > 0 )
	//  (3146) END
	{
		int	iRow;
		int	iColumn;

		pSplitter->GetActivePane(
			&iRow,
			&iColumn
		);

		CPoint	ptOld;
		ptOld = GetDeviceScrollPosition();
		CPoint	ptNew = ptOld;
		ptNew.x = lPos;
 		SetDeviceScrollPosition( ptNew );

		pSplitter->DoScrollBy( this, ptOld.x-ptNew.x );
		for ( int idxRow=0 ; idxRow<pSplitter->GetRowCount() ; idxRow++ )
		{
			CWnd*	pWnd = pSplitter->GetPane( idxRow, iColumn );
			((CShitarabianView*)pWnd)->HScrollCore(
				SB_THUMBPOSITION,
				lPos,
				GetScrollBarCtrl( SB_HORZ ),
				ptOld
			);
		}
	}
}




void CShitarabianView::ManualVScroll( long lPos ) 
{
	CSplitterWnd*	pSplitter = ((CMainFrame*)::AfxGetMainWnd())->GetSplitter();

	//  (3146) BGN 2003.11.21 (dincom) yC̑݃`FbN
	if ( pSplitter->GetColumnCount() * pSplitter->GetRowCount() > 0 )
	//  (3146) END
	{
		int	iRow;
		int	iColumn;
		pSplitter->GetActivePane(
			&iRow,
			&iColumn
		);

		CPoint	ptOld;
		ptOld = GetDeviceScrollPosition();
		CPoint	ptNew = ptOld;
		ptNew.y = lPos;
 		SetDeviceScrollPosition( ptNew );

		for ( int idxColumn=0 ; idxColumn<pSplitter->GetColumnCount() ; idxColumn++ )
		{
			CWnd*	pWnd = pSplitter->GetPane( iRow, idxColumn );
			((CShitarabianView*)pWnd)->VScrollCore(
				SB_THUMBPOSITION,
				lPos,
				GetScrollBarCtrl( SB_VERT ),
				ptOld
			);
		}
	}
}


void CShitarabianView::VScrollCore(
	UINT		nSBCode,
	UINT		nPos,
	CScrollBar*	pScrollBar,
	CPoint		ptOldScroll
)
{
	// warning C4100:x̖
	pScrollBar; nPos; 

	CEditDrawer*		pDrawer = GetDrawer();
	int	lRowHeight = pDrawer->GetBlankHeight() + CGeneralSetting::GetInstance()->GetRowGap();
	lRowHeight *= pDrawer->GetZoom();

	CRect		rcClient;
	GetClientRect( &rcClient );

	CPoint		ptMyPaneOldScroll = GetDeviceScrollPosition();
	ptOldScroll.x = ptMyPaneOldScroll.x;

	BOOL	bNeedReDraw = FALSE;
	// SetFocusƕ`悪̂͂܂̂łƂ肠
	// TNbNSetFocus()Ƃɂ͏ȂBplease!Ȃł̂H
	if ( m_idxUpdateStartRow == InitialRow )
	if ( m_idxUpdateEndRow == InitialRow )
	{
		bNeedReDraw = TRUE;
	}

	CPoint		ptScroll = ptOldScroll;
	int			iPos = ptScroll.y;

	switch( nSBCode )
	{
	case SB_TOP:		
		break;
	case SB_BOTTOM:			// Scroll to bottom.
		break;
	case SB_ENDSCROLL:		// End scroll.
		return;
		break;
	case SB_LINEDOWN:		// Scroll one line down.
		switch( CGeneralSetting::GetInstance()->GetVScrollUnit() )
		{
		case Scroll1Pixel:
			iPos += 1;
			break;
		case Scroll1Row:
			iPos += lRowHeight;
			break;
		case Scroll2Row:
			iPos += lRowHeight*2;
			break;
		default:
			break;
		}
		break;
	case SB_LINEUP:			// Scroll one line up.
		switch( CGeneralSetting::GetInstance()->GetVScrollUnit() )
		{
		case Scroll1Pixel:
			iPos -= 1;
			break;
		case Scroll1Row:
			iPos -= lRowHeight;
			break;
		case Scroll2Row:
			iPos -= lRowHeight*2;
			break;
		default:
			break;
		}
		break;
	case SB_PAGEDOWN:		// Scroll one page down.
		iPos += rcClient.Height();
		break;
	case SB_PAGEUP:			// Scroll one page up.
		iPos -= rcClient.Height();
		break;
	case SB_THUMBPOSITION:	// Scroll to the absolute position. The current position is provided in nPos.
	case SB_THUMBTRACK:		// Drag scroll box to specified position. The current position is provided in nPos.
		{
			SCROLLINFO	tInfo;
			GetScrollInfo( SB_VERT, &tInfo );
			iPos = tInfo.nTrackPos;
		}
		break;
	default:
		break;
	}

	ptScroll.y = iPos;

	// XN[{bNX̉摜炷Kvȗ̈ĕ`
	UpdateScrollBox(
		ptOldScroll,
		ptScroll,
		rcClient
	);
 	SetDeviceScrollPosition( ptScroll );

	// ĕ`
	CShitarabianDoc* pDoc = GetDocument();
	if ( bNeedReDraw )
	{
//		pDoc->ReDraw( this );
	}
}


void CShitarabianView::HScrollCore(
	UINT		nSBCode,
	UINT		nPos,
	CScrollBar*	pScrollBar,
	CPoint		ptOldScroll
)
{
	// warning C4100:x̖
	pScrollBar; nPos; 

	CEditDrawer*		pDrawer = GetDrawer();
	int	lCharWidth = pDrawer->GetBlankWidth();
	lCharWidth *= pDrawer->GetZoom();

	CPoint		ptMyPaneOldScroll = GetDeviceScrollPosition();
	ptOldScroll.y = ptMyPaneOldScroll.y;

	CRect		rcClient;
	GetClientRect( &rcClient );

//	BOOL	bNeedReDraw = TRUE;
	// SetFocusƕ`悪̂͂܂̂łƂ肠
	// TNbNSetFocus()Ƃɂ͏ȂBplease!Ȃł̂H
	if ( m_idxUpdateStartRow != InitialRow )
	if ( m_idxUpdateEndRow != InitialRow )
	{
//		bNeedReDraw = FALSE;
	}

	CPoint		ptScroll = ptOldScroll;
	int			iPos = ptScroll.x;

	switch( nSBCode )
	{
	case SB_TOP:		
		break;
	case SB_BOTTOM:			// Scroll to bottom.
		break;
	case SB_ENDSCROLL:		// End scroll.
		break;
	case SB_LINEDOWN:		// Scroll one line down.
		switch( CGeneralSetting::GetInstance()->GetHScrollUnit() )
		{
		case Scroll1Pixel:
			iPos += 1;
			break;
		case Scroll1Char:
			iPos += lCharWidth;
			break;
		case Scroll2Char:
			iPos += lCharWidth*2;
			break;
		default:
			break;
		}
		break;
	case SB_LINEUP:			// Scroll one line up.
		switch( CGeneralSetting::GetInstance()->GetHScrollUnit() )
		{
		case Scroll1Pixel:
			iPos -= 1;
			break;
		case Scroll1Char:
			iPos -= lCharWidth;
			break;
		case Scroll2Char:
			iPos -= lCharWidth*2;
			break;
		default:
			break;
		}
		break;
	case SB_PAGEDOWN:		// Scroll one page down.
		iPos += rcClient.Width();
		break;
	case SB_PAGEUP:			// Scroll one page up.
		iPos -= rcClient.Width();
		break;
	case SB_THUMBPOSITION:	// Scroll to the absolute position. The current position is provided in nPos.
	case SB_THUMBTRACK:		// Drag scroll box to specified position. The current position is provided in nPos.
		{
			SCROLLINFO	tInfo;
			GetScrollInfo( SB_HORZ, &tInfo );
			iPos = tInfo.nTrackPos;
		}
		break;
	default:
		break;
	}

	ptScroll.x = iPos;

	// XN[{bNX̉摜炷Kvȗ̈ĕ`
/*
	UpdateScrollBox(
		ptOldScroll,
		ptScroll,
		rcClient
	);
*/
	SetDeviceScrollPosition( ptScroll );

	// ĕ`
	CShitarabianDoc* pDoc = GetDocument();
//	if ( bNeedReDraw )
	{
		// XN[̂Ƃ͋IɂׂĂ`
		pDoc->SetAllUpdate();
		pDoc->ReDraw( this );
	}
}


void CShitarabianView::DrawToROI(
	CDC*		pDstDC,
	int			iDstLeft,
	int			iDstTop,
	CRect		rcSrc
) 
{
	CEditDrawer*		pDrawer = CEditDrawer::GetInstance();
	CShitarabianDoc*	pDoc = GetDocument();

	// y[Ws
	int		iLineHeight = pDrawer->CaretRowToPixel( 1 );

	// 鑍s
	int		iStartLine = rcSrc.top / iLineHeight;
	int		iEndLine = rcSrc.bottom / iLineHeight;

	// cb쐬
	CBitmap*	pOldBitmap;
	CDC			MemDC;
	CDC*		pSrcDC = GetDC();
	{
		MemDC.CreateCompatibleDC ( pSrcDC );
		CBitmap		MemBitmap;
		MemBitmap.CreateCompatibleBitmap(
			pSrcDC,
			rcSrc.Width(),
			rcSrc.Height()
		);
		pOldBitmap = MemDC.SelectObject( &MemBitmap );

		COLORREF	colBack = ::GetBackColor( EMPHASIS_TEXT );
		MemDC.FillSolidRect(
			0,0,
			rcSrc.Width(),
			rcSrc.Height(),
			colBack
		);
		MemDC.SetMapMode( MM_TEXT );
	}

	// eLXg̕\
	pDrawer->SetUpdateRect( rcSrc );
	int		idxLine;
	for( idxLine=iStartLine ; idxLine<=iEndLine ; idxLine++ )
	{
		int		iRow = idxLine - iStartLine;

		// s`
		{
			CString*			pstr = pDoc->GetLine( idxLine );
			if ( pstr != NULL )
			{
				long boom = iRow * iLineHeight;
				boom -= ( rcSrc.top - iStartLine*iLineHeight );
				CPoint	pt;
				pt.x = -rcSrc.left;
				pt.y = boom;
				pDrawer->SetDstX( pt.x );
				pDrawer->SetDstY( pt.y );

				long	lXPixel;

				lXPixel = pDrawer->DrawPlaneLine(
						pDoc,
						&MemDC,
						idxLine,
//						rcSrc.Width(),
						FALSE
				);
			}
		}
	}
	pDrawer->SetUpdateRect( CRect(0,0,0,0) );

	pDstDC->BitBlt(
		iDstLeft,
		iDstTop,
		rcSrc.Width(),
		rcSrc.Height(),
		&MemDC,
		0,
		0,
		SRCCOPY
	);

	MemDC.SelectObject( pOldBitmap );

	ReleaseDC( pSrcDC );
}

